Subject: Re: bug#66117: 30.0.50; `find-buffer-visiting' is slow when opening large number of buffers

From: Ihor Radchenko <[email-masked]>
Date: Tue, 19 Dec 2023 13:24:12 +0000

Eli Zaretskii <[email-masked]> writes:

>> > I'm talking specifically about any changes from previous behavior
>> > visible from Lisp.  I think we should test all of the following:
>> >
>> >   default-value
>> >   default-boundp
>> >   setq-default
>> >   default-toplevel-value
>> >   set-default-toplevel-value
>> >
>> > and make sure they all behave exactly the same, both in and out of a
>> > let-binding.
>> 
>> The patch did not introduce test failures for make check on my side. Are
>> there existing tests for buffer-locals? Or do we need to add them?
>
> I don't see any such tests.  So yes, it would be good to add them.
> But at the very least we should consider all of the above
> theoretically and see if any of them are expected/supposed to change
> as result of this.

Do you still think that we need to discuss special cases further, after
Stefan's reply?

If yes, I will need help with various edge cases, because I am not
really sure about them. For example, I have no clue if below is expected

(defvar test/foo 'value)
(default-boundp 'test/foo)
(default-value 'test/foo) ;; -> value
(let ((test/foo t))
  (default-value 'test/foo)) ;; -> t ???

(defvar-local test/foo2 'value)
(default-boundp 'test/foo2) ;; -> t
(default-value 'test/foo2) ;; -> value
(let ((test/foo2 t))
  (default-value 'test/foo2)) ;; -> t ???
(setq-default test/foo2 'value2)
(default-boundp 'test/foo2) ;; -> t
(default-value 'test/foo2) ;; -> value2
(let ((test/foo2 t))
  (default-value 'test/foo2)) ;; -> t ???

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>